unit PBtn;

// 08.02.2001 by Peric
// E-Mail PericDDN@ppt.yu
// For D2,D3,D4,D5.......
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ExtCtrls, Menus,MMSystem;
  {$R PBtn.res}
type
  TOnMouseOverEvent = procedure(Sender: TObject) of object;
  TOnMouseOutEvent = procedure(Sender: TObject) of object;
  TNumGlyphs = 1..2;
  TNumGlyphsHot = 1..2;
  TMarginStyle=(msNone,msDefault);
  TPBtn = class(TGraphicControl)
  private
    Fspaceg,Fspacegh,Fgap:integer;
    FMark: TBitmap;
    FNumGlyphs: TNumGlyphs;
    FNumGlyphsHot: TNumGlyphsHot;
    FTCGlyph,FTCGlyphHot,FTCGlyphDisabled:TColor;
    FGlyph,FGlyphHot: TBitmap;
    FCuGlyph,FCuGlyphHot: TBitmap;
    FColorHighLight,FColorOver: TColor;
    FColorShadow: TColor;
    FMouseInPos: Boolean;
    FX,FM:integer;
    FMenuMark: boolean;
    FSong:boolean;
    FColorOverOn:boolean;
    FMarginStyle:TMarginStyle;
    FCop:String;
    FOnMouseOver: TOnMouseOverEvent;
    FOnMouseOut: TOnMouseOutEvent;
    FPopupMenu: TPopupMenu;
    function GetCop: string;
    procedure SetNumGlyphs(value: TNumGlyphs);
    procedure SetNumGlyphsHot(value: TNumGlyphsHot);
    procedure SetCop(const Value: string);
    procedure CMMouseEnter(var AMsg: TMessage);
      message CM_MOUSEENTER;
    procedure CMMouseLeave(var AMsg: TMessage);
      message CM_MOUSELEAVE;
    procedure SetColor(index: integer; value: TColor);
    procedure SetGlyph(value: TBitmap);
    procedure SetGlyphHot(value: TBitmap);
    procedure SetMenuMark(value: boolean);
    procedure SetSong(Asong: boolean);
    procedure SetGap(AGap: integer);
    procedure SetColorOver(Value: TColor);
    procedure SetColorOverOn(AColorOverOn: boolean);
    procedure SetMarginStyle(Value:TMarginStyle);
    procedure CmVisibleChanged(var Message: TWmNoParams); message CM_VISIBLECHANGED;
  protected
  procedure Music(song : pchar);
  procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
   procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
   procedure Paint; override;
   procedure Click;override;
   procedure GG;
   procedure GH;
   procedure SetPopupMenu(value: TPopupMenu);
   procedure Notification(AComponent: TComponent; Operation: TOperation); override;
   procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
   procedure CMSysColorChange(var Message: TMessage); message CM_SYSCOLORCHANGE;
  public
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
  published
   property Glyph: TBitmap read FGlyph write SetGlyph;
   property GlyphHot: TBitmap read FGlyphHot write SetGlyphHot;
   property MenuMark: boolean read FMenuMark write SetMenuMark default False;
   property OnMouseOver: TOnMouseOverEvent read FOnMouseOver write FOnMouseOver;
   property OnMouseOut: TOnMouseOutEvent read FOnMouseOut write FOnMouseOut;
   property MarginColorLight: TColor index 1 read FColorHighLight write SetColor default clBtnHighLight;
   property MarginColorShadow: TColor index 2 read FColorShadow write SetColor default clBtnShadow;
   property ColorOver: TColor read FColorover write SetColorover default clBtnHighLight;
   property PopupMenu: TPopupMenu read FPopupMenu write SetPopupMenu;
   property Visible;//: boolean read FVisible write SetVisible default True;
   property PlayMusic: boolean read FSong write SetSong default False;
   property ColorOverOn: boolean read FColorOverOn write SetColorOverOn default False;
   property MarginStyle: TMarginStyle read FMarginStyle write SetMarginStyle default msDefault;
   property Gap: integer read FGap write SetGap default 4;
   property Color;
   property Enabled;
   property ShowHint;
   property ParentColor;
   property Copyright: string read GetCop write SetCop;
   property NumGlyphs: TNumGlyphs read FNumGlyphs write SetNumGlyphs default 2;
   property NumGlyphsHot: TNumGlyphsHot read FNumGlyphsHot write SetNumGlyphsHot default 2;
   property OnClick;
   property OnDblClick;
   property OnDragDrop;
   property OnDragOver;
   property OnEndDrag;
   Property OnMouseDown;
   property OnMouseUp;
   property OnMouseMove;
   property OnStartDrag;

   
  end;

procedure Register;

implementation
var R:Trect;
    i:integer;
    colorit:Tcolor;
procedure Register;
begin
  RegisterComponents('PDJ', [TPBtn]);
end;

constructor TPBtn.Create(AOwner: TComponent);

begin
inherited Create(AOwner);
SetBounds(0, 0, 25, 25);
FColorHighLight := clBtnHighLight;
FColorShadow := clBtnShadow;
FColorover := clBtnHighLight;
FMouseInPos:=false;
Fx:=0;
FM:=1;
FGap:=4;
FGlyph := TBitmap.Create;
FGlyphHot := TBitmap.Create;
FCuGlyph := TBitmap.Create;
FCuGlyphHot := TBitmap.Create;
FMark := TBitmap.Create;
FCop:='Copyright  2001 by Peric';
FNumGlyphs :=2;
FNumGlyphsHot :=2;
Fspaceg:=0;
Fspacegh:=0;
FMenuMark:=False;
fsong:=false;
FColorOverOn:=false;
FMarginStyle:=msDefault;
end;

procedure TPBtn.CMSysColorChange(var Message: TMessage);
begin
  Repaint;
end;

procedure TPBtn.SetMarginStyle(value: TMarginStyle);
begin
begin
  if value <> FMarginStyle then
  begin
    FMarginStyle := value;

case FMarginStyle of
msNone:FM:=0;
msDefault:FM:=1;
end;

repaint;

end;
end;
end;

procedure TPBtn.SetColorOver(Value: TColor);
begin
  FColorOver:=Value;
end;

procedure TPBtn.SetColorOverOn(AColorOverOn: boolean);
begin
FColorOverOn:=AColorOverOn;
end;

procedure TPBtn.Music(song : pchar);
var
  h: THandle;
  p: pointer;
begin
  h := FindResource(hInstance,song,'WAV');
  h := LoadResource(hInstance, h);
  p := LockResource(h);
  sndPlaySound(p,SND_MEMORY or SND_SYNC);
  UnLockResource(h);
  FreeResource(h);
 end;

 procedure TPbtn.SetSong(Asong:boolean);
 begin
 Fsong:=Asong;
 end;

procedure TPBtn.SetGap(AGap:integer);
begin
FGap:=AGap;
Repaint;
end;

procedure TPBtn.CMEnabledChanged(var Message: TMessage);
begin
 if FMenuMark then
  begin
    if Enabled then
      FMark.Handle := LoadBitmap(HInstance, 'T')
    else
      FMark.Handle := LoadBitmap(HInstance, 'TE');
  end;
  Repaint;  
end;

procedure TPBtn.SetMenuMark(value: boolean);

begin

  if (value <> FMenuMark) then
    FMenuMark := value;

  if FMenuMark then
  begin 
    if Enabled then
      FMark.Handle := LoadBitmap(HInstance, 'T')
    else
      FMark.Handle := LoadBitmap(HInstance, 'TE');
      end
      else
      begin
      Fmark.handle:=LoadBitmap(HInstance, 'B');
      end;
      
      if FMenuMark then
      begin

      Fspaceg:=6;
      Fspacegh:=6;
      end
      else
      begin
    
      Fspaceg:=0;
      Fspacegh:=0;
      end;
  Repaint;
end;




function TPBtn.GetCop: string;
begin
Result:=FCop;
end;


procedure TPBtn.SetCop(const Value: string);
begin
FCop:=FCop;
end;


destructor TPBtn.Destroy;
begin
FGlyph.Free;
FGlyphHot.Free;
FMark.Free;
FCuGlyph.Free;
FCuGlyphHot.Free;

inherited Destroy;
end;

procedure TPBtn.CMColorChanged(var Message: TMessage);
begin
  Repaint;
end;


procedure TPBtn.SetNumGlyphs(value: TNumGlyphs);
begin
  if value <> FNumGlyphs then
  begin
    FNumGlyphs := value;
    Repaint;
  end;
end;

procedure TPBtn.SetNumGlyphsHot(value: TNumGlyphsHot);
begin
  if value <> FNumGlyphsHot then
  begin
    FNumGlyphsHot := value;
    Repaint;
  end;
end;


procedure TPBtn.CmVisibleChanged(var Message: TWmNoParams);
begin
  inherited;
  Repaint;
end;

procedure TPBtn.SetPopupMenu(value: TPopupMenu);
begin
  FPopupMenu := Value;
  if Value <> nil then
  begin
    Value.FreeNotification(Self);
   repaint;
  end;
end;

procedure TPBtn.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = FPopupMenu) then FPopupMenu := nil;
end;



procedure TPBtn.SetColor(index: integer; value: TColor);
begin
case index of
1: if value <> FColorHighLight then
begin
FColorHighLight := value;
Repaint;
end;
2: if value <> FColorShadow then
begin
FColorShadow := value;
Repaint;
end;
end;
end;

procedure TPBtn.CMMouseEnter(var AMsg: TMessage);

begin
Colorit:=color;
if not enabled then exit;
if Assigned(FOnMouseOver) then FOnMouseOver(Self);
FMouseInPos:=True;
if FColorOverOn then color:=FColorOver;
if Fsong then music('nad');
R:=clientRect;
Frame3d(canvas, R, FColorHighLight,FColorShadow,FM);
canvas.FillRect(r);

i:=0;
if not enabled then
GG else GH;
Fx:=0;


end;


procedure TPBtn.CMMouseLeave(var AMsg: TMessage);
begin
if not enabled then exit;
if Assigned(FOnMouseOut) then FOnMouseOut(Self);
FMouseInpos:=False;
if FColorOverOn then color:=colorit;
R:=clientRect;
Frame3d(canvas, R, clnone,clnone,0);
canvas.FillRect(r);
GG;
Fx:=1;
i:=0;
end;


procedure TPBtn.MouseUp(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
if Button<>mbleft then exit else begin

if not enabled then exit;
if fx=1 then exit;
R:=clientRect;
Frame3d(canvas, R, FColorHighLight,FColorShadow,FM);
canvas.FillRect(r);
i:=0;
if not enabled then
GG else GH;
end;

inherited MouseUp(Button, Shift, X, Y);
end;

procedure TPBtn.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
  var 
  q: TPoint;
Begin
if Button<>mbleft then exit else begin

if not enabled then exit;
R:=clientRect;
Frame3d(canvas, R, FColorShadow,FColorHighLight,FM);
canvas.FillRect(r);
i:=1;
if not enabled then
GG else GH;
 if FPopupMenu = nil then exit;
  FPopupMenu.AutoPopup:= false;
  q.X:= 0;
  q.Y:= 0;
  q:= ClientToScreen(q);
  FPopupMenu.Popup(q.X - 1, q.Y + Height);
R:=clientRect;
Frame3d(canvas, R, clnone,clnone,0);
canvas.FillRect(r);
 GG;
 i:=0;
end;

inherited MouseDown(Button, Shift, X, Y);
end;

procedure TPBtn.Paint;

begin
R:=clientRect;
canvas.brush.color:=color;
Frame3d(canvas, R, FColorHighLight,FColorShadow,FM);
canvas.FillRect(r);

GG;
if csDesigning in ComponentState then
Exit;
R:=clientRect;
canvas.brush.color:=color;
Frame3d(canvas, R, clnone,clnone,0);
canvas.FillRect(r);
GG;
end;



procedure TPBtn.SetGlyph(value: TBitmap);
begin
  if value <> FGlyph then
  begin
    FGlyph.Assign(value);
    if not FGlyph.Empty then
    begin
    if FGlyph.Width mod FGlyph.Height = 0 then
      begin
        FNumGlyphs := FGlyph.Width div FGlyph.Height;
        if FNumGlyphs > 2 then FNumGlyphs := 1;
        repaint
      end;
      end
     else
     repaint;

  end;
end;

procedure TPBtn.SetGlyphHot(value: TBitmap);
begin
  if value <> FGlyphHot then
  begin
    FGlyphHot.Assign(value);
    if not FGlyphHot.Empty then
    begin
    if FGlyphHot.Width mod FGlyphHot.Height = 0 then
      begin
        FNumGlyphsHot := FGlyphHot.Width div FGlyphHot.Height;
        if FNumGlyphsHot > 2 then FNumGlyphsHot := 1;
        repaint
      end;
      end
     else
     repaint;
  end;
  end;



procedure TPBtn.GG;
var G,B,M,S,D,T,MT:TRect;
Xg,Yg,Xv,Yv:integer;
begin
if  FGlyph.Empty then Exit;
if enabled then
S := Rect(0, 0, FGlyph.Width div FNumGlyphs, FGlyph.Height)
else
S := Rect(FGlyph.Width div FNumGlyphs, 0,FGlyph.Width , FGlyph.Height);
D := Rect(0, 0, FGlyph.Width div FNumGlyphs, FGlyph.Height);
FCuGlyph.Width := FGlyph.Width div FNumGlyphs;
FCuGlyph.Height := FGlyph.Height;
FCuGlyph.Canvas.CopyRect(D, FGlyph.Canvas, S);
B:=Rect(0,0, FCuGlyph.Width, Fcuglyph.Height);
T:=Rect(0,0, FMark.Width, FMark.Height);
Xv:=(R.right-R.left);
Yv:=(R.bottom-R.top);
Xg:= ((Xv-(((Xv-FCuGlyph.Width)div 2)+FCUglyph.width))-1)- Fspaceg;
Yg:= ((Yv-(((Yv-FCuglyph.Width)div 2)+FCuglyph.width))-1);
M:=Rect(R.left+Xg, R.top+Yg, Xg+R.left+FCuglyph.width,Yg+R.top+ FCuglyph.height);
FTCGlyph := FCuGlyph.Canvas.Pixels[0, FCuGlyph.Height - 1];
canvas.BrushCopy(M, FCuglyph,B, FTCGlyph);
mt:=Rect(r.left+xg+FCuGlyph.width+FGap, r.top+yg, xg+r.left+FCuGlyph.width+FGap+FMark.width,yg+r.top+ FMark.height);
canvas.BrushCopy(mt, Fmark,t, clfuchsia);
end;

procedure TPBtn.GH;
var Gh,Bh,Mh,Sh,Dh,Th,Mth:TRect;
Xgh,Ygh,Xvh,Yvh:integer;
begin
if  FGlyphHot.Empty then Exit;
Sh := Rect(0, 0, FGlyphHot.Width div FNumGlyphsHot, FGlyphHot.Height);
Dh := Rect(0, 0, FGlyphHot.Width div FNumGlyphsHot, FGlyphHot.Height);
FCuGlyphHot.Width := FGlyphHot.Width div FNumGlyphsHot;
FCuGlyphHot.Height := FGlyphHot.Height;
FCuGlyphHot.Canvas.CopyRect(Dh, FGlyphHot.Canvas, Sh);
Bh:=Rect(0,0, FCuGlyphHot.Width, FCuglyphHot.Height);
Th:=Rect(0,0, FMark.Width, FMark.Height);
Xvh:=(R.right-R.left);
Yvh:=(R.bottom-R.top);
Xgh:= ((Xvh-(((Xvh-FCuGlyphHot.Width)div 2)+FCuglyphHot.width))-1)- Fspacegh;
Ygh:= ((Yvh-(((Yvh-FCuglyphHot.Width)div 2)+FCuglyphHot.width))-1);
Mh:=Rect(R.left+Xgh+i, R.top+Ygh+i, Xgh+R.left+FCuglyphHot.width+i,Ygh+R.top+ FCuglyphHot.height+i);
FTCGlyphHot := FCuGlyphHot.Canvas.Pixels[0, FCuGlyphHot.Height - 1];
canvas.BrushCopy(Mh, FCuglyphHot,Bh, FTCGlyphHot);
Mth:=Rect(r.left+xgh+FCuGlyphHot.width+FGap+i, r.top+ygh+i, xgh+r.left+FCuGlyphHot.width+FGap+FMark.width+i,ygh+r.top+ FMark.height+i);
canvas.BrushCopy(mth, Fmark,th, clfuchsia);
end;

procedure TPBtn.Click;
begin
inherited;
end;





end.
